script 455 (int which, int mode)
{
    int x, y, z;
    x = GetActorX(0); y = GetActorY(0); z = GetActorZ(0);
    SetActivatorToTarget(0);
    int pln = PlayerNumber();

    which = condFalse(which, 456);
    TrailModes[pln] = middle(0, mode, TRAILCOUNT-1);

    ACS_ExecuteAlways(which, 0, x,y,z);
    ACS_ExecuteWithResult(469, x,y,z);
}

script 456 (int tx, int ty, int tz) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int i, k = 0, l;
    int ii, p;
    int x, y, z;
    int vx, vy, vz, mag, magI;

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + 24.0;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    for (i = 48; i < magI; i += 24)
    {
        Spawn("LascannonBurstEffect", x+(vx*i), y+(vy*i), z+(vz*i));
    }
}

script 457 (int tx, int ty, int tz) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int i, k = 0, l;
    int x, y, z;
    int vx, vy, vz, mag, magI;
    int density = GetCVar("lelweps_noclipssgdensity");

    if (density <= 0)
    {
        ConsoleCommand("set lelweps_noclipssgdensity 24");
        ConsoleCommand("archivecvar lelweps_noclipssgdensity");
        density = 24;
    }

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + 24.0;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    for (i = 48; i < magI; i += density)
    {
        Spawn("SuperNoclipTrail", x+(vx*i), y+(vy*i), z+(vz*i));

        l += (i - k);
        Delay(l / 192);
        l %= 192;
        k = i;
    }
}

script 459 (int tx, int ty, int tz) clientside
{
    if (ConsolePlayerNumber() == -1) { terminate; }

    int i, k = 0, l;
    int x, y, z;
    int ii, p;
    int vx, vy, vz, mag, magI;

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + 24.0;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    for (i = 48; i < magI; i += 16)
    {
        Spawn("LasgunTrail", x+(vx*i), y+(vy*i), z+(vz*i));
    }
}

int TempCoords[PLAYERMAX][3];

script 469 (int tx, int ty, int tz)
{
    if (!IsServer) { terminate; }

    int pln = PlayerNumber();
    int item    = TrailItems     [TrailModes[pln]];
    int start   = TrailStarts    [TrailModes[pln]];
    int density = TrailDensities [TrailModes[pln]];
    int i, k = 0, l;
    int ii;
    int x, y, z;
    int vx, vy, vz, mag, magI;

    x  = GetActorX(0); y =  GetActorY(0);  z = GetActorZ(0) + 24.0;

    vx = tx-x; vy = ty-y; vz = tz-z; mag = magnitudeThree_f(vx, vy, vz);
    vx = FixedDiv(vx, mag); vy = FixedDiv(vy, mag); vz = FixedDiv(vz, mag);
    magI = ftoi(mag);

    for (i = start; i < magI; i += density)
    {
        TempCoords[pln][0] = (vx * i);
        TempCoords[pln][1] = (vy * i);
        TempCoords[pln][2] = (vz * i);
        GiveInventory(item, 1);
    }
}

script 468 (int which)
{
    int pln = PlayerNumber();
    int ret = 0;

    switch (which)
    {
        case 0: ret = TempCoords[pln][0]; break;
        case 1: ret = TempCoords[pln][1]; break;
        case 2: ret = TempCoords[pln][2]; break;
    }

    SetResultValue(ftoi(ret));
}
