script 585 (int divI, int divF)
{
    int div = percFloat(divI, divF);

    int x = GetActorVelX(0);
    int y = GetActorVelY(0);
    int z = GetActorVelZ(0);

    SetActorVelocity(0, FixedDiv(x, div), FixedDiv(y, div), FixedDiv(z, div), 0, 1);
}

script 586 (int speedInt, int speedFrac)
{
    int x = GetActorVelX(0);
    int y = GetActorVelY(0);
    int z = GetActorVelZ(0);
    int mag = magnitudeThree_f(x, y, z);
    int speed = percFloat(speedInt, speedFrac);

    if (mag <= 0.05) { terminate; }

    x = FixedMul(FixedDiv(x, mag), speed);
    y = FixedMul(FixedDiv(y, mag), speed);
    z = FixedMul(FixedDiv(z, mag), speed);

    SetActorVelocity(0, x, y, z, 0, 1);
}
